from typing import List

from aldryn_search.helpers import get_plugin_index_data
from aldryn_search.utils import clean_join
from cms.models import CMSPlugin
from cms.models import Placeholder
from django.http import HttpRequest


def render_text_from_placeholders(placeholders: List[Placeholder], lang_code: str, request: HttpRequest) -> str:
    indexable_strings: List[str] = []
    for placeholder in placeholders:
        indexable_strings.append(render_text_from_placeholder(placeholder, lang_code, request))
    return clean_join(' ', indexable_strings)


def render_text_from_placeholder(placeholder: Placeholder, lang_code: str, request: HttpRequest) -> str:
    indexable_strings: List[str] = []
    plugins = CMSPlugin.objects.filter(language=lang_code).filter(placeholder=placeholder)
    for plugin in plugins:
        plugin_text_content = render_text_from_plugin(plugin, request)
        indexable_strings.append(plugin_text_content)
    return clean_join(' ', indexable_strings)


def render_text_from_plugin(plugin: CMSPlugin, request: HttpRequest) -> str:
    return clean_join(' ', get_plugin_index_data(plugin, request))
